/*
 * The MIT License
 *
 * Copyright 2017 Germán Bordel <german.bordel at ehu.es>.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package edu.upvehu.gb.paralelismo;

import java.awt.Color;
import java.awt.Graphics;
import javax.swing.JPanel;

/**
 * JPanel que puede correr en un hilo mostrando una particula moviendose aleatoriamente
 * 
 * @author Germán Bordel <german.bordel at ehu.es>
 */
public class JPanelBrowniano extends JPanel implements Runnable{
    private final double SPACE_QUANTUM=10.0; 
    private final int DIAMETRO=10;
    private final int ESPERA=30;
    private int x,y;
    
    @Override
    public void paint(Graphics g) {
        super.paint(g); 
        g.setColor(Color.red);
        g.fillOval(x, y, DIAMETRO, DIAMETRO);
    }

    @Override
    public void run() {
        x=getWidth()/2;
        y=getHeight()/2;
        while (true) {
            x=(x+=(int)(SPACE_QUANTUM *(Math.random()-0.5)))<0?0:x>getWidth()-1-DIAMETRO?getWidth()-1-DIAMETRO:x;
            y=(y+=(int)(SPACE_QUANTUM *(Math.random()-0.5)))<0?0:y>getHeight()-1-DIAMETRO?getHeight()-1-DIAMETRO:y;
            repaint();
            try { Thread.sleep(ESPERA); } catch (InterruptedException ignore) {}
        }

    }
    
}
