/*
 * The MIT License
 *
 * Copyright 2017 Germán Bordel <german.bordel at ehu.es>.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package edu.upvehu.gb.paralelismo;

/**
 * Ejecución del ejemplo con un JFrame en el que tres tareas se ejecutan en paralelo 
 * 
 * @author Germán Bordel <german.bordel at ehu.es>
 */
public class Paralelismo {
    static String texto="En un lugar de la Mancha, de cuyo nombre no quiero acordarme, no ha mucho tiempo que vivía"
            + " un hidalgo de los de lanza en astillero, adarga antigua, rocín flaco y galgo corredor."
            + " Una olla de algo más vaca que carnero, salpicón las más noches, duelos y quebrantos los sábados,"
            + " lentejas los viernes, algún palomino de añadidura los domingos, consumían las tres partes de su"
            + " hacienda. El resto della concluían sayo de velarte, calzas de velludo para las fiestas con sus"
            + " pantuflos de lo mismo, los días de entre semana se honraba con su vellori de lo más fino."
            + " Tenía en su casa una ama que pasaba de los cuarenta, y una sobrina que no llegaba a los veinte,"
            + " y un mozo de campo y plaza, que así ensillaba el rocín como tomaba la podadera. Frisaba la edad"
            + " de nuestro hidalgo con los cincuenta años, era de complexión recia, seco de carnes,"
            + " enjuto de rostro; gran madrugador y amigo de la caza. Quieren decir que tenía el sobrenombre"
            + " de Quijada o Quesada (que en esto hay alguna diferencia en los autores que deste caso escriben),"
            + " aunque por conjeturas verosímiles se deja entender que se llama Quijana; pero esto importa poco"
            + " a nuestro cuento; basta que en la narración dél no se salga un punto de la verdad.";

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels())
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ParalelismoGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ParalelismoGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ParalelismoGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ParalelismoGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new ParalelismoGUI(texto).setVisible(true);
           }
        });
        
        
    }
    
}
